# Papaya

## Lancer l'application
Il faut ``Node`` installé sur votre machine. Ensuite, depuis le dossier server/, lancer les commandes ``npm install`` et ``npm start``.

## Pour tester
 - Sur AssemblyNet, dans le navigateur, aller à l'adresse:
   http://localhost:5000/preview?hash=625e4aeb37529d8a95120c7891620dd8cd0837f5f8a71261f832a2f49105a955

 - Sur DeepLesionBrain (version volbrain) dans le navigateur, aller à l'adresse:
http://localhost:5000/preview?hash=625e4aeb37529d8a95120c7891620dd8cd0837f5f8a71261f832a2f49105a956 


## Lancer les tests
Il faut ``Node`` installé sur votre machine. Lancer l'application puis depuis le dossier server/, lancer la commande ``npm run tests <id>``. 
L'id désigne le type de pipeline à tester :
<ul>
    <li>1 : AssemblyNet</li>
    <li>2 : DeepLesionBrain</li>
</ul>

## Travail réalisé 

### Sprint 1 
<b>Dates : </b>24 février 2022 - 1er mars 2022

<b>Tâches réalisées :</b>
- Mise en place de l'existant : 
    - Adaptation du front
    - Mise à jour de la version de ``Papaya`` utilisée
    - Réadaptation de la taille du module ``Papaya``
    - Affichage de l'orientation de la coupe du cerveau
    - Création du back
    - Mise en forme des données d'entrées
- Création de nouveaux onglets
- Développement du MVP (``Minimum Viable Product``) :
    - Affichage des informations propres à une zone selectionnée via un clique gauche :
        - le titre
        - la description
        - la courbe de normalité (les courbes et zone de confiance 95% avec la librairie ``ChartJS``)
    - Suppression des éléments non nécessaires :
        - l'onglet Jobs
        - le status du job
        - le nom du fichier ouvert
- Gestion des calques :
    - Affichage des calques
    - Création de checkbox pour masquer et afficher les calques

<b>Remarques : </b>

Les informations affichées correspondent au label sélectionné. Si la zone selectionnée correspond au fond de l'image (``background``) ou non défini (``undefined``), alors aucune information n'est affichée.</br>
Certains labels n'ont pas de description.

### Sprint 2
<b>Dates : </b>02 mars 2022 - 08 mars 2022

<b>Tâches réalisées :</b>
- Gestion des calques :
    - Affichage des calques
    - Remplacer les checkbox par un menu déroulant
    - Séparer les calques par catégorie
    - Pouvoir avoir un seul et unique calque actif de chaque catégorie
    - Raccourcis pour les calques
    - Options des calques dans l'input
- Resize du viewer papaya pour afficher les boutons
- Légender et afficher un point sur la courbe de normalité
- Selection de la courbe de normalitée correspondante au sexe du patient.
- Mise en place de l'outil de test
- Stockage des labels et descriptions dans des fichiers JSON
- Affichage des boutons de réponse à la question de satisfaction "yes" et "no" dans l'onglet informations
- Créer et afficher le formulaire de satisfaction dans l'onglet QC
- Affichage des descriptions à l'aide d'un bouton permettant de les afficher/cacher. Les descriptions ne sont pas affichées de base.

### Sprint 3
<b>Dates : </b>09 mars 2022 - 16 mars 2022

<b>Tâches réalisées :</b>
- Changement de "background image"  à "image"
- Mise à jour des informations lorsqu'on deplace la crossbar de différentes manières
- Cacher toute la partie information lorsqu'on clique sur le background
- Cacher/Afficher la partie QC si l'utilisateur accepte de partager ses images ou non
- Mettre un a minuscule à Analysis dans l'onglet QC
- Ajouter numPad en raccourcis pour afficher/cacher les calques
- Adaptation de l'affichage des icônes du header pour toutes les tailles d'écran
- Suppression du label "medium" dans l'affichage des courbes de normalités
- Afficher la courbe de normalité pour tous les calques
- Suppression du champs file dans la navbar  
- Ajout de nouvelles tables de couleurs
- Reduction des marges dans l'onglet QC
- Bouton "Yes" redirige vers l'onglet QC
- La taille maximum des commentaires possible est de 250 caractères
- Bouton pour télécharger en CSV le QC
- Prise en compte du hash dans l'URL afin de charger différents jobs

### Sprint 4

<b>Dates : </b>16 mars 2022 - 23 mars 2022

<b>Tâches réalisées :</b>
- Suppression du bouton CSV Comments de la navbar
- Correction bug fléche button description
- Update information quand on passe d'un calque à un autre
- Change le calque lorsqu'on le selectionne dans la toolbar
- Boutton YES / NO sur la même ligne que la phrase
- Application fonctionnelle pour DeepLesionBrain pipeline
- Bloquer le nombre de caractères à 280
- Suppression des mots image et segmentation dans le QC
- Un champ commentaire est affiché si on sélectionne good dans qc , rien si on ne selectionne rien et une zone de commentaire + des checkbox si medium ou bad
- Pré-saisie des réponses dans l'onglet QC en fonction de la réponse de l'utilisateur à la question de satisfaction
- Changer les colorTables avec le script
- Apparation du bouton DL CSV après send
- Tooltip sur les boutons contenant un icon 
- Mise en place d'un début de solution pour l’édition (upload d’une image .nii ou .nii.gz et affichage de l'image chargée dans le viewer de Papaya)
- Bouton EDIT à la place des boutons YES / NO si le job possède déjà un commentaire


### Sprint 5
<b>Dates : </b>23 mars 2022 - 30 mars 2022

<b>Tâches réalisées :</b>
- Ajout du sexe et de l'age du patient
- Ajout une colonne issue dans le CSV
- Marge entre image et segmantion dans QC
- Revoir l'arborescence (refactor)
- Sync DL CSV avec commentExist
