//https://sequelize.org/v6/manual/model-querying-basics.html
const Rating = require("../models/ratingsModel");

//param withDrop:
//  -True => table va être drop d'abord
//  -False => si la table existe, rien ne se produira
async function createTable(withDrop) {
  await Rating.sync({ force: withDrop });

  console.log("Ratings table created");
}

async function dropTable() {
  await Rating.drop();
}

async function createRating(username, pipelineId, rating, comment) {
  const newRating = await Rating.create({
    username: username,
    pipelineId: pipelineId,
    rating: rating,
    comment: comment,
  });

  console.log("New rating created : " + JSON.stringify(newRating));
}

async function displayTable() {
  const ratings = await Rating.findAll();

  console.log("All ratings:", JSON.stringify(ratings, null, 2));
}

module.exports = { createTable, createRating, displayTable };
