//https://sequelize.org/v6/manual/model-basics.html
const { DataTypes } = require("sequelize");

const { sequelize } = require("../config/db");

//Rating model pour notre dB
const Rating = sequelize.define("ratings", {
  //Pourquoi pas en id faire : [username]_[pipelineId]
  id: {
    type: DataTypes.INTEGER,
    primaryKey: true,
    autoIncrement: true,
  },
  username: {
    type: DataTypes.STRING,
    allowNull: false,
  },
  pipelineId: {
    type: DataTypes.INTEGER,
    allowNull: false,
  },
  rating: {
    type: DataTypes.FLOAT,
    defaultValue: 0,
  },
  comment: {
    //type: DataTypes.TEXT (à voir)
    type: DataTypes.STRING,
    defaultValue: "",
  },
});

module.exports = Rating;
