/**
 * Used to show the file selected in the input
 * Inspired by https://tympanus.net/Tutorials/CustomFileInputs/
 */

let inputs = document.querySelectorAll( '.inputfile' );
Array.prototype.forEach.call( inputs, function( input ){
	let label	 = input.nextElementSibling,
	labelVal = label.innerHTML;

	input.addEventListener( 'change', function( e ){
		let fileName = e.target.value.split( '\\' ).pop();

		if( fileName )
			label.querySelector( 'span' ).innerHTML = fileName;
		else
			label.innerHTML = labelVal;
	});

	// Firefox bug fix
	input.addEventListener( 'focus', function(){ input.classList.add( 'has-focus' ); });
	input.addEventListener( 'blur', function(){ input.classList.remove( 'has-focus' ); });
});