function loadingComplete() {
    console.log("Loaded");
    // Load only the overlay with enabled true in options and change the current overlay
    for (let index = 0; index < this.viewer.screenVolumes.length; index++) {
        const name = this.viewer.screenVolumes[index].volume.fileName;
        const isHide = !this.params[name].enabled;
        this.viewer.screenVolumes[index].hidden = isHide;
        if (!isHide) {
            this.viewer.setCurrentScreenVol(index);
        }
    }
    // Update the viewer and the toolbar
    this.viewer.drawViewer(true, false);
    this.toolbar.updateImageButtons();

    $("button.papaya-control-increment").toggleClass("btn btn-user-preview");
    $("button.papaya-control-decrement").toggleClass("btn btn-user-preview");
    $("button.papaya-control-swap").toggleClass("btn btn-user-preview");
    $("button.papaya-control-goto-origin").toggleClass("btn btn-user-preview");
    $("button.papaya-control-goto-center").toggleClass("btn btn-user-preview");
    $("button.papaya-main-increment").toggleClass("btn btn-user-preview");
    $("button.papaya-main-decrement").toggleClass("btn btn-user-preview");
    $("button.papaya-main-swap").toggleClass("btn btn-user-preview");
    $("button.papaya-main-goto-origin").toggleClass("btn btn-user-preview");
    $("button.papaya-main-goto-center").toggleClass("btn btn-user-preview");
    $("span.papaya-menu-button").appendTo($("#preview_controls"));
}

var params = [];
if (niiFiles != undefined && niiFiles.length > 0) {
    for (let i = 0; i < niiFiles.length; i++) {
        let fileName = niiFiles[i];
        if (fileName === "") {
            niiFiles.splice(i, 1);
        }
    }
}

if (niiOptions != undefined && niiOptions.length > 0) {
    let options = { min: 0, max: 100, lut: "Spectrum" };
    for (var i = 0; i < niiOptions.length; i++) {
        let fileUrl = niiFiles[i];
        let fileOpt = niiOptions[i];
        if (
            fileOpt.hasOwnProperty("image") &&
            fileOpt.hasOwnProperty("options")
        ) {
            params[fileOpt.image] = fileOpt.options;
        } else {
            params[fileUrl] = options;
        }
    }
}

params["kioskMode"] = kioskMode ? true : false;
params["fullScreen"] = false;
params["fullScreenPadding"] = false;
params["worldSpace"] = true;
params["showControlBar"] = true;
params["loadingComplete"] = loadingComplete;
params["images"] = niiFiles;
params["binaryImages"] = [];
params["noNewFiles"] = true;
params["mainView"] = "surface";
params["showSurfacePlanes"] = false;
params["smoothDisplay"] = true;
params["radiological"] = false;
params["hideFile"] = true;
