// Label
let CURRENT_LABEL = -1;

// Update Label/Plot when you click and move 
papaya.viewer.Viewer.prototype.updatePosition = function (viewer, xLoc, yLoc, crosshairsOnly) {
    var xImageLoc, yImageLoc, temp, originalX, originalY, surfaceCoord;

    showLabel(this.currentScreenVolume.volume.fileName);
    displayPlot();
    this.canvas.parentNode.setAttribute("label", CURRENT_LABEL);    

    viewer.updateOffsetRect();
    originalX = xLoc;
    originalY = yLoc;
    xLoc = xLoc - this.canvasRect.left;
    yLoc = yLoc - this.canvasRect.top;
    if (this.insideScreenSlice(viewer.axialSlice, xLoc, yLoc, viewer.volume.getXDim(), viewer.volume.getYDim())) {
        if (!this.isDragging || (this.draggingSliceDir === papaya.viewer.ScreenSlice.DIRECTION_AXIAL)) {
            xImageLoc = this.convertScreenToImageCoordinateX(xLoc, viewer.axialSlice);
            yImageLoc = this.convertScreenToImageCoordinateY(yLoc, viewer.axialSlice);
            if ((xImageLoc !== viewer.currentCoord.x) || (yImageLoc !== viewer.currentCoord.y)) {
                viewer.currentCoord.x = xImageLoc;
                viewer.currentCoord.y = yImageLoc;
                this.draggingSliceDir = papaya.viewer.ScreenSlice.DIRECTION_AXIAL;
            }
        }
    } else if (this.insideScreenSlice(viewer.coronalSlice, xLoc, yLoc, viewer.volume.getXDim(),
            viewer.volume.getZDim())) {
        if (!this.isDragging || (this.draggingSliceDir === papaya.viewer.ScreenSlice.DIRECTION_CORONAL)) {
            xImageLoc = this.convertScreenToImageCoordinateX(xLoc, viewer.coronalSlice);
            yImageLoc = this.convertScreenToImageCoordinateY(yLoc, viewer.coronalSlice);
            if ((xImageLoc !== viewer.currentCoord.x) || (yImageLoc !== viewer.currentCoord.y)) {
                viewer.currentCoord.x = xImageLoc;
                viewer.currentCoord.z = yImageLoc;
                this.draggingSliceDir = papaya.viewer.ScreenSlice.DIRECTION_CORONAL;
            }
        }
    } else if (this.insideScreenSlice(viewer.sagittalSlice, xLoc, yLoc, viewer.volume.getYDim(),
            viewer.volume.getZDim())) {
        if (!this.isDragging || (this.draggingSliceDir === papaya.viewer.ScreenSlice.DIRECTION_SAGITTAL)) {
            xImageLoc = this.convertScreenToImageCoordinateX(xLoc, viewer.sagittalSlice);
            yImageLoc = this.convertScreenToImageCoordinateY(yLoc, viewer.sagittalSlice);
            if ((xImageLoc !== viewer.currentCoord.x) || (yImageLoc !== viewer.currentCoord.y)) {
                temp = xImageLoc;
                viewer.currentCoord.y = temp;
                viewer.currentCoord.z = yImageLoc;
                this.draggingSliceDir = papaya.viewer.ScreenSlice.DIRECTION_SAGITTAL;
            }
        }
    } else if (viewer.surfaceView && this.insideScreenSlice(viewer.surfaceView, xLoc, yLoc, viewer.surfaceView.screenDim,
            viewer.surfaceView.screenDim)) {
        viewer.surfaceView.updateDynamic(originalX, originalY, (this.selectedSlice === this.mainImage) ? 1 : 3);
    }

    this.container.coordinateChanged(this);
    viewer.drawViewer(false, crosshairsOnly);
};

// Update Label/Plot when move crossbar
papaya.viewer.Viewer.prototype.gotoCoordinate = function (coor, nosync) {
    if (!this.initialized) {
        return;
    }

    var xDim = this.volume.header.imageDimensions.xDim;
    var yDim = this.volume.header.imageDimensions.yDim;
    var zDim = this.volume.header.imageDimensions.zDim;

    if (coor.x < 0) {
        this.currentCoord.x = 0;
    } else if (coor.x >= xDim) {
        this.currentCoord.x = (xDim - 1);
    } else {
        this.currentCoord.x = coor.x;
    }

    if (coor.y < 0) {
        this.currentCoord.y = 0;
    } else if (coor.y >= yDim) {
        this.currentCoord.y = (yDim - 1);
    } else {
        this.currentCoord.y = coor.y;
    }

    if (coor.z < 0) {
        this.currentCoord.z = 0;
    } else if (coor.z >= zDim) {
        this.currentCoord.z = (zDim - 1);
    } else {
        this.currentCoord.z = coor.z;
    }

    this.drawViewer(true);
    this.updateSliceSliderControl();

    showLabel(this.currentScreenVolume.volume.fileName);
    displayPlot();
    this.canvas.parentNode.setAttribute("label", CURRENT_LABEL);    

    if (nosync) {
        return;
    }

    this.container.coordinateChanged(this);
    this.drawViewer(false);
};

papaya.viewer.Viewer.prototype.toggleOverlay = function (imageIndex) {
    var screenVol, screenVolNeg;
    screenVol = this.screenVolumes[imageIndex];
    const screenCat = screenVol.volume.params[screenVol.volume.fileName].category;
    // Hide all volumes of the same category
    for (let index = 0; index < screenVol.volume.params["images"].length; index++) {
        const imgName = this.screenVolumes[index].volume.fileName
        if(this.screenVolumes[this.screenVolumes.length - 1].volume.params[imgName].category === screenCat && this.screenVolumes[index] !== screenVol){ // this.container.viewer.screenVolumes[this.container.viewer.screenVolumes.length - 1].volume.params[imgName].category
            this.screenVolumes[index].hidden = true
        }
    }
    // Show the selected volume
    screenVol.hidden = !screenVol.hidden;
    screenVolNeg = screenVol.negativeScreenVol;
    if (this.container.combineParametric && screenVolNeg) {
        screenVolNeg.hidden = !screenVolNeg.hidden;
    }

    document.getElementsByName(screenCat).forEach(function (elem) {
        elem.value = (screenVol.hidden)? screenCat : screenVol.volume.fileName;
    });

    this.drawViewer(true, false);

    showLabel(this.currentScreenVolume.volume.fileName);
    displayPlot();
    this.canvas.parentNode.setAttribute("label", CURRENT_LABEL);    

    return screenVol.hidden;
};


// Ratio for Canvas size (change ratio value)
papaya.Container.prototype.getViewerDimensions = function () {
    var parentWidth, height, width, ratio, maxHeight, maxWidth;

    parentWidth = this.containerHtml.parent().width() - (this.fullScreenPadding ? (2 * PAPAYA_PADDING) : 0);
    ratio = (this.orthogonal ? (this.hasSurface() ? 1.333 : 2) : 1);

    if (this.orthogonalTall || !this.orthogonal) {
        height = (this.collapsable ? window.innerHeight : this.containerHtml.parent().height()) - (papaya.viewer.Display.SIZE + (this.kioskMode ? 0 : (papaya.ui.Toolbar.SIZE +
            PAPAYA_SPACING)) + PAPAYA_SPACING + (this.fullScreenPadding && !this.nestedViewer ? (2 * PAPAYA_CONTAINER_PADDING_TOP) : 0)) -
            (this.showControlBar ? 2*papaya.ui.Toolbar.SIZE : 0);

        width = papayaRoundFast(height / ratio);
    } else {

        width = parentWidth;
        height = papayaRoundFast(width / ratio);
    }

    if (!this.nestedViewer || this.collapsable) {

        if (this.orthogonalTall) {

            maxWidth = window.innerWidth - (this.fullScreenPadding ? (2 * PAPAYA_PADDING) : 0);
            if (width > maxWidth) {
                width = maxWidth;
                height = papayaRoundFast(width * ratio);
            }
        } else {

            maxHeight = window.innerHeight - (papaya.viewer.Display.SIZE + (this.kioskMode ? 0 : (papaya.ui.Toolbar.SIZE +
                PAPAYA_SPACING)) + PAPAYA_SPACING + (this.fullScreenPadding ? (2 * PAPAYA_CONTAINER_PADDING_TOP) : 0)) -
                (this.showControlBar ? 2*papaya.ui.Toolbar.SIZE : 0);
            if (height > maxHeight) {
                height = maxHeight;
                width = papayaRoundFast(height * ratio);
            }

        }
    }

    return [width, height];
};

//shorcuts for overlay
const KEYCODE_ONE = 49;
const KEYCODE_ONE_NUMPAD = 97;

const MAX_NUMBER_OVERLAY = 10;
const KEYCODE_TOGGLE_SEGMENTATION = 83;
papaya.Container.KEYBOARD_REF_TEXT += "<br/><br/>"+
    "<span style='color:#B5CBD3'>[1,2,...,9]</span> Toggle the overlay of this index.<br /><br />"+
    "<span style='color:#B5CBD3'>[s]</span> Toggle current overlay of segmentation.";

papaya.viewer.Viewer.prototype.keyDownEvent = function (ke) {
    var keyCode, center;

    this.keyPressIgnored = false;
    if(document.getElementById("comments").className.includes("active")){
        return;
    }
    if (this.container.toolbar.isShowingMenus()) {
        return;
    }

    if (((papayaContainers.length > 1) || papayaContainers[0].nestedViewer) && (papaya.Container.papayaLastHoveredViewer !== this)) {
        return;
    }

    keyCode = papaya.viewer.Viewer.getKeyCode(ke);

    if (papaya.viewer.Viewer.isControlKey(ke)) {
        this.isControlKeyDown = true;
    } else if (papaya.viewer.Viewer.isAltKey(ke)) {
        this.isAltKeyDown = true;
    } else if (papaya.viewer.Viewer.isShiftKey(ke)) {
        this.isShiftKeyDown = true;
    } else if (keyCode === papaya.viewer.Viewer.KEYCODE_ROTATE_VIEWS) {
        this.rotateViews();
    } else if (keyCode === papaya.viewer.Viewer.KEYCODE_CENTER) {
        center = new papaya.core.Coordinate(Math.floor(this.volume.header.imageDimensions.xDim / 2),
            Math.floor(this.volume.header.imageDimensions.yDim / 2),
            Math.floor(this.volume.header.imageDimensions.zDim / 2));
        this.gotoCoordinate(center);
    } else if (keyCode === papaya.viewer.Viewer.KEYCODE_ORIGIN) {
        this.gotoCoordinate(this.volume.header.origin);
    } else if (keyCode === papaya.viewer.Viewer.KEYCODE_ARROW_UP) {
        this.incrementCoronal(false);
    } else if (keyCode === papaya.viewer.Viewer.KEYCODE_ARROW_DOWN) {
        this.incrementCoronal(true);
    } else if (keyCode === papaya.viewer.Viewer.KEYCODE_ARROW_LEFT) {
        this.incrementSagittal(true);
    } else if (keyCode === papaya.viewer.Viewer.KEYCODE_ARROW_RIGHT) {
        this.incrementSagittal(false);
    } else if ((keyCode === papaya.viewer.Viewer.KEYCODE_PAGE_DOWN) ||
        (keyCode === papaya.viewer.Viewer.KEYCODE_FORWARD_SLASH)) {
        this.incrementAxial(true);
    } else if ((keyCode === papaya.viewer.Viewer.KEYCODE_PAGE_UP) ||
        (keyCode === papaya.viewer.Viewer.KEYCODE_SINGLE_QUOTE)) {
        this.incrementAxial(false);
    } else if (keyCode === papaya.viewer.Viewer.KEYCODE_INCREMENT_MAIN) {
        if (this.mainImage.sliceDirection === papaya.viewer.ScreenSlice.DIRECTION_AXIAL) {
            this.incrementAxial(false);
        } else if (this.mainImage.sliceDirection === papaya.viewer.ScreenSlice.DIRECTION_CORONAL) {
            this.incrementCoronal(false);
        } else if (this.mainImage.sliceDirection === papaya.viewer.ScreenSlice.DIRECTION_SAGITTAL) {
            this.incrementSagittal(true);
        }
    } else if (keyCode === papaya.viewer.Viewer.KEYCODE_DECREMENT_MAIN) {
        if (this.mainImage.sliceDirection === papaya.viewer.ScreenSlice.DIRECTION_AXIAL) {
            this.incrementAxial(true);
        } else if (this.mainImage.sliceDirection === papaya.viewer.ScreenSlice.DIRECTION_CORONAL) {
            this.incrementCoronal(true);
        } else if (this.mainImage.sliceDirection === papaya.viewer.ScreenSlice.DIRECTION_SAGITTAL) {
            this.incrementSagittal(false);
        }
    } else if (keyCode === papaya.viewer.Viewer.KEYCODE_TOGGLE_CROSSHAIRS) {
        if (this.container.preferences.showCrosshairs === "Yes") {
            this.toggleMainCrosshairs = !this.toggleMainCrosshairs;
            this.drawViewer(true);
        }
    } else if (keyCode === papaya.viewer.Viewer.KEYCODE_SERIES_FORWARD) {
        this.incrementSeriesPoint();
    } else if (keyCode === papaya.viewer.Viewer.KEYCODE_SERIES_BACK) {
        this.decrementSeriesPoint();
    } else if (keyCode === papaya.viewer.Viewer.KEYCODE_RULER) {
        if (this.container.preferences.showRuler === "Yes") {
            this.container.preferences.showRuler = "No";
        } else {
            this.container.preferences.showRuler = "Yes";
        }
        this.drawViewer(true, true);    
    } else if (keyCode === KEYCODE_TOGGLE_SEGMENTATION){
        const index = this.container.viewer.screenVolumes.indexOf(this.currentScreenVolume)
        this.toggleOverlay(index);
    // 1...9 Shortcut (&,é,",...)
    } else if (keyCode >= KEYCODE_ONE && keyCode < KEYCODE_ONE + this.screenVolumes.length) { // OVERLAY SHORTCUT
        for (let index = 0; index < this.screenVolumes.length && this.screenVolumes.length < MAX_NUMBER_OVERLAY; index++) {
            if(keyCode === KEYCODE_ONE + index){
                this.toggleOverlay(index)
                console.log(this);
                this.setCurrentScreenVol(index);
                this.container.toolbar.updateImageButtons();
            }
        }
    // NUMPAD SHORTCUT
    } else if (keyCode >= KEYCODE_ONE_NUMPAD && keyCode < KEYCODE_ONE_NUMPAD + this.screenVolumes.length) { // OVERLAY SHORTCUT
        for (let index = 0; index < this.screenVolumes.length && this.screenVolumes.length < MAX_NUMBER_OVERLAY; index++) {
            if(keyCode === KEYCODE_ONE_NUMPAD + index){
                this.toggleOverlay(index)
                console.log(this);
                this.setCurrentScreenVol(index);
                this.container.toolbar.updateImageButtons();
            }
        }
    } else {
        this.keyPressIgnored = true;
    }

    if (!this.keyPressIgnored) {
        ke.handled = true;
        ke.preventDefault();
    }
};

// papaya.viewer.Display.prototype.drawEmptyDisplay = function () {
//     if (this.canDraw()) {
//         this.viewer.canvas.parentNode.setAttribute("label", undefined);
//         this.context.clearRect(0, 0, this.canvas.width, this.canvas.height);
//         this.context.fillStyle = "#000000";
//         this.context.fillRect(0, 0, this.canvas.width, this.canvas.height);
//     } else if (this.drawError) {
//         this.drawError(this.errorMessage);
//     }
// };

// Delete file in toolbar
papaya.ui.Toolbar.prototype.buildToolbar = function () {
    var ctr;

    this.imageMenus = null;
    this.surfaceMenus = null;
    this.spaceMenu = null;

    this.container.toolbarHtml.find("." + PAPAYA_MENU_ICON_CSS).remove();
    this.container.toolbarHtml.find("." + PAPAYA_MENU_LABEL_CSS).remove();
    this.container.toolbarHtml.find("." + PAPAYA_TITLEBAR_CSS).remove();

    if (this.container.kioskMode) {
        for (ctr = 0; ctr < papaya.ui.Toolbar.MENU_DATA_KIOSK.menus.length; ctr += 1) {
            this.buildMenu(papaya.ui.Toolbar.MENU_DATA_KIOSK.menus[ctr], null, this.viewer, null);
        }
    } else {
        if(!this.container.params.hideFile){
            ctr = 0
            if ((this.container.viewer.screenVolumes.length > 0) && this.container.viewer.screenVolumes[0].rgb) {
                papaya.ui.Toolbar.MENU_DATA.menus[0] = papaya.ui.Toolbar.RGB_FILE_MENU_DATA;
            } else {
                if (this.container.noNewFiles) {
                    papaya.ui.Toolbar.MENU_DATA.menus[0] = papaya.ui.Toolbar.RGB_FILE_MENU_DATA;
                } else {
                    papaya.ui.Toolbar.MENU_DATA.menus[0] = papaya.ui.Toolbar.FILE_MENU_DATA;
                }
            }
        }else{
            ctr = 1
        }
        this.buildOpenMenuItems(papaya.ui.Toolbar.MENU_DATA);

        for (ctr; ctr < papaya.ui.Toolbar.MENU_DATA.menus.length; ctr += 1) {
            this.buildMenu(papaya.ui.Toolbar.MENU_DATA.menus[ctr], null, this.viewer, null);
        }

        this.buildAtlasMenu();
    }

    this.buildColorMenuItems();

    this.container.titlebarHtml = this.container.containerHtml.find("." + PAPAYA_TITLEBAR_CSS);
    if (this.container.getViewerDimensions()[0] < 600) {
        this.container.titlebarHtml.css({visibility: "hidden"});
    } else {
        this.container.titlebarHtml.css({visibility: "visible"});
    }
};

// Change overlay when you select

papaya.ui.Toolbar.OVERLAY_IMAGE_MENU_DATA = {
    "items": [
        {"label": "Show Header", "action": "ShowHeader"},
        {"label": "Show Image Info", "action": "ImageInfo"},
        {"type": "spacer", "required": "isParametricCombined"},
        {"label": "DisplayRange", "action": "ChangeRange", "type": "displayrange", "method": "getRange"},
        {"label": "Load Negatives", "action": "LoadNegatives", "required" : "canCurrentOverlayLoadNegatives" },
        {"label": "Transparency", "action": "alpha", "type": "range", "method": "getAlpha"},
        {"label": "Color Table", "action": "ColorTable", "items": [], "required": "isNonParametricCombined" },
        {"type": "spacer", "required": "isParametricCombined"},
        {"label": "DisplayRange", "action": "ChangeRangeNeg", "type": "displayrange", "method": "getRangeNegative", "required": "isParametricCombined"},
        {"label": "Transparency", "action": "alphaneg", "type": "range", "method": "getAlpha", "required": "isParametricCombined"},
        {"type": "spacer", "required": "isParametricCombined"},
        {"label": "Open in Mango", "action": "OpenInMango", "required" : "canOpenInMango" }
    ]
};


papaya.ui.Toolbar.prototype.doAction = function (action, file, keepopen) {
    var imageIndex, colorTableName, dialog, atlasName, imageName, folder, ctr, ctrI, ignored;

    if (!keepopen) {
        this.closeAllMenus();
    }

    if (action) {
        if (action.startsWith("ImageButton")) {
            imageIndex = parseInt(action.substr(action.length - 2, 1), 10);
            this.viewer.setCurrentScreenVol(imageIndex)
            if(this.viewer.screenVolumes[imageIndex].hidden){
                this.container.viewer.toggleOverlay(imageIndex);
            }
            this.updateImageButtons();
        } else if (action.startsWith("OpenSurface-")) {
            imageName = action.substring(action.indexOf("-") + 1);
            this.viewer.loadSurface(imageName);
        } else if (action.startsWith("Open-")) {
            imageName = action.substring(action.indexOf("-") + 1);
            this.viewer.loadImage(imageName);
        } else if (action === "OpenImage") {
            this.container.display.drawProgress(0.1, "Loading");
            this.viewer.loadImage(file);
        } else if (action === "OpenDTI") {
            this.container.display.drawProgress(0.1, "Loading");
            this.viewer.loadingDTI = true;
            this.viewer.loadImage(file);
        } else if (action === "OpenSurface") {
            this.container.display.drawProgress(0.1, "Loading");
            this.viewer.loadSurface(file);
        } else if (action === "OpenFolder") {
            folder = [];
            for (ctr = 0; ctr < file.length; ctr += 1) {
                ignored = false;

                for (ctrI = 0; ctrI < papaya.Container.ignorePatterns.length; ctrI += 1) {
                    if (papaya.Container.ignorePatterns[ctrI].test(file[ctr].name)) {
                        ignored = true;
                    }
                }

                if (ignored) {
                    console.log("Ignoring file " + file[ctr].name);
                } else {
                    folder.push(file[ctr]);
                }
            }

            this.container.display.drawProgress(0.1, "Loading");
            this.viewer.loadImage(folder);
        } else if (action.startsWith("ColorTable")) {
            colorTableName = action.substring(action.indexOf("-") + 1, action.lastIndexOf("-"));
            imageIndex = action.substring(action.lastIndexOf("-") + 1);
            this.viewer.screenVolumes[imageIndex].changeColorTable(this.viewer, colorTableName);
            this.updateImageButtons();
        } else if (action.startsWith("CloseAllImages")) {
            papaya.Container.resetViewer(this.container.containerIndex, {});
        } else if (action === "Preferences") {
            dialog = new papaya.ui.Dialog(this.container, "Viewer Preferences", papaya.ui.Toolbar.PREFERENCES_DATA,
                this.container.preferences, papaya.utilities.ObjectUtils.bind(this.container.preferences,
                    this.container.preferences.updatePreference),
                    papaya.utilities.ObjectUtils.bind(this,
                        function() {
                            this.viewer.updateScreenSliceTransforms();
                            this.viewer.drawViewer(false, true);
                        }
                    )
            );
            dialog.showDialog();
        } else if (action === "SurfacePreferences") {
            dialog = new papaya.ui.Dialog(this.container, "Surface Preferences", papaya.ui.Toolbar.PREFERENCES_SURFACE_DATA,
                this.container.preferences, papaya.utilities.ObjectUtils.bind(this.container.preferences,
                    this.container.preferences.updatePreference),
                papaya.utilities.ObjectUtils.bind(this,
                    function() {
                        this.viewer.updateScreenSliceTransforms();
                        this.viewer.surfaceView.updatePreferences();
                        this.viewer.drawViewer(false, true);
                    }
                )
            );
            dialog.showDialog();
        } else if (action === "License") {
            dialog = new papaya.ui.Dialog(this.container, "License", papaya.ui.Toolbar.LICENSE_DATA,
                papaya.Container, null, null, null, true);
            dialog.showDialog();
        } else if (action === "KeyboardRef") {
            dialog = new papaya.ui.Dialog(this.container, "Keyboard Reference", papaya.ui.Toolbar.KEYBOARD_REF_DATA,
                papaya.Container, null, null, null, true);
            dialog.showDialog();
        } else if (action === "MouseRef") {
            dialog = new papaya.ui.Dialog(this.container, "Mouse Reference", papaya.ui.Toolbar.MOUSE_REF_DATA,
                papaya.Container, null, null, null, true);
            dialog.showDialog();
        } else if (action.startsWith("ImageInfo")) {
            imageIndex = action.substring(action.lastIndexOf("-") + 1);

            if (this.viewer.screenVolumes[imageIndex].volume.numTimepoints > 1) {
                dialog = new papaya.ui.Dialog(this.container, "Image Info", papaya.ui.Toolbar.SERIES_INFO_DATA,
                    this.viewer, null, null, imageIndex.toString());
            } else {
                dialog = new papaya.ui.Dialog(this.container, "Image Info", papaya.ui.Toolbar.IMAGE_INFO_DATA,
                    this.viewer, null, null, imageIndex.toString());
            }

            dialog.showDialog();
        } else if (action.startsWith("SurfaceInfo")) {
            imageIndex = action.substring(action.lastIndexOf("-") + 1);

            dialog = new papaya.ui.Dialog(this.container, "Surface Info", papaya.ui.Toolbar.SURFACE_INFO_DATA,
                this.viewer, null, null, imageIndex.toString());
            dialog.showDialog();
        } else if (action.startsWith("ShowHeader")) {
            imageIndex = action.substring(action.lastIndexOf("-") + 1);

            dialog = new papaya.ui.Dialog(this.container, "Header", papaya.ui.Toolbar.HEADER_DATA,
                this.viewer, null, null, imageIndex.toString());

            dialog.showDialog();
        } else if (action.startsWith("SPACE")) {
            this.viewer.toggleWorldSpace();
            this.viewer.drawViewer(true);
        } else if (action.startsWith("AtlasChanged")) {
            atlasName = action.substring(action.lastIndexOf("-") + 1);
            this.viewer.atlas.currentAtlas = atlasName;
            this.viewer.drawViewer(true);
        } else if (action.startsWith("ShowRuler")) {
            if (this.container.preferences.showRuler === "Yes") {
                this.container.preferences.updatePreference("showRuler", "No");
            } else {
                this.container.preferences.updatePreference("showRuler", "Yes");
            }
            this.viewer.drawViewer();
            this.closeAllMenus();
        } else if (action.startsWith("ShowOrientation")) {
            if (this.container.preferences.showOrientation === "Yes") {
                this.container.preferences.updatePreference("showOrientation", "No");
            } else {
                this.container.preferences.updatePreference("showOrientation", "Yes");
            }
            this.viewer.drawViewer();
            this.closeAllMenus();
        } else if (action.startsWith("ShowCrosshairs")) {
            if (this.container.preferences.showCrosshairs === "Yes") {
                this.container.preferences.updatePreference("showCrosshairs", "No");
            } else {
                this.container.preferences.updatePreference("showCrosshairs", "Yes");
            }

            this.viewer.drawViewer();
            this.closeAllMenus();
        } else if (action.startsWith("EXPAND")) {
            if (this.container.collapsable) {
                this.container.collapseViewer();
            } else {
                this.container.expandViewer();
            }
        } else if (action.startsWith("OpenInMango")) {
            imageIndex = parseInt(action.substring(action.lastIndexOf("-") + 1), 10);

            if (imageIndex === 0) {
                if (this.container.viewer.volume.urls[0]) {
                    papaya.utilities.PlatformUtils.launchCustomProtocol(this.container, papaya.utilities.UrlUtils.getAbsoluteUrl(PAPAYA_CUSTOM_PROTOCOL,
                        this.container.viewer.volume.urls[0]), this.customProtocolResult);
                }
            } else {
                if (this.container.viewer.screenVolumes[imageIndex].volume.urls[0]) {
                    papaya.utilities.PlatformUtils.launchCustomProtocol(this.container, papaya.utilities.UrlUtils.getAbsoluteUrl(PAPAYA_CUSTOM_PROTOCOL,
                        this.container.viewer.screenVolumes[imageIndex].volume.urls[0]) + "?" +
                    encodeURIComponent("baseimage=" + this.container.viewer.volume.fileName + "&params=o"),
                        this.customProtocolResult);
                }
            }
        } else if (action.startsWith("CloseOverlay")) {
            imageIndex = parseInt(action.substring(action.lastIndexOf("-") + 1), 10);
            this.container.viewer.removeOverlay(imageIndex);
        } else if (action.startsWith("ToggleOverlay")) {
            imageIndex = parseInt(action.substring(action.lastIndexOf("-") + 1), 10);
            this.container.viewer.toggleOverlay(imageIndex);
        } else if (action.startsWith("Context-")) {
            this.container.contextManager.actionPerformed(action.substring(8));
        } else if (action.startsWith("DTI-RGB")) {
            imageIndex = action.substring(action.lastIndexOf("-") + 1);
            this.viewer.screenVolumes[imageIndex].dtiLines = false;
            this.viewer.screenVolumes[imageIndex].dtiColors = true;
            this.viewer.screenVolumes[imageIndex].initDTI();
            this.viewer.drawViewer(true, false);
        } else if (action.startsWith("DTI-LinesColors")) {
            imageIndex = action.substring(action.lastIndexOf("-") + 1);
            this.viewer.screenVolumes[imageIndex].dtiLines = true;
            this.viewer.screenVolumes[imageIndex].dtiColors = true;
            this.viewer.screenVolumes[imageIndex].initDTI();
            this.viewer.drawViewer(true, false);
        } else if (action.startsWith("DTI-Lines")) {
            imageIndex = action.substring(action.lastIndexOf("-") + 1);
            this.viewer.screenVolumes[imageIndex].dtiLines = true;
            this.viewer.screenVolumes[imageIndex].dtiColors = false;
            this.viewer.screenVolumes[imageIndex].initDTI();
            this.viewer.drawViewer(true, false);
        } else if (action.startsWith("DTI-Mod")) {
            imageIndex = action.substring(action.lastIndexOf("-") + 1);
            this.container.display.drawProgress(0.1, "Loading");
            this.viewer.loadingDTIModRef = this.viewer.screenVolumes[imageIndex];
            this.viewer.loadImage(file);
        } else if (action.startsWith("LoadNegatives")) {
            imageIndex = action.substring(action.lastIndexOf("-") + 1);
            this.viewer.addParametric(imageIndex);
        } else if (action.startsWith("ShowSurfacePlanes")) {
            this.viewer.surfaceView.showSurfacePlanes = !this.viewer.surfaceView.showSurfacePlanes;
            this.viewer.surfaceView.updateActivePlanes();

            if (this.container.preferences.showSurfacePlanes === "Yes") {
                this.container.preferences.updatePreference("showSurfacePlanes", "No");
            } else {
                this.container.preferences.updatePreference("showSurfacePlanes", "Yes");
            }
            this.viewer.drawViewer(false, true);
            this.closeAllMenus();
        } else if (action.startsWith("ShowSurfaceCrosshairs")) {
            this.viewer.surfaceView.showSurfaceCrosshairs = !this.viewer.surfaceView.showSurfaceCrosshairs;
            this.viewer.surfaceView.updateActivePlanes();

            if (this.container.preferences.showSurfaceCrosshairs === "Yes") {
                this.container.preferences.updatePreference("showSurfaceCrosshairs", "No");
            } else {
                this.container.preferences.updatePreference("showSurfaceCrosshairs", "Yes");
            }
            this.viewer.drawViewer(false, true);
            this.closeAllMenus();
        } else if (action.startsWith("rotation")) {
            this.viewer.screenVolumes[0].updateTransform();
        } else if (action.startsWith("Rotate About")) {
            this.viewer.screenVolumes[0].rotationAbout = action.substring(0, action.indexOf("-"));
            this.viewer.screenVolumes[0].updateTransform();
            this.viewer.drawViewer(true, false);
        } else if (action.startsWith("ResetTransform")) {
            this.viewer.screenVolumes[0].resetTransform();
            this.viewer.screenVolumes[0].updateTransform();
            this.viewer.drawViewer(true, false);
        }
    }
};


/**
 * Adapts Papaya's drag and drop behavior to update the interface and allow Volbrain features to work
 */
papaya.Container.prototype.setUpDnD = function () {
    var container = this;

    this.containerHtml[0].ondragover = function () {
        container.viewer.draggingOver = true;
        if (!container.viewer.initialized) {
            container.viewer.drawEmptyViewer();
        }

        return false;
    };

    this.containerHtml[0].ondragleave = function () {
        container.viewer.draggingOver = false;
        if (!container.viewer.initialized) {
            container.viewer.drawEmptyViewer();
        }
        return false;
    };

    this.containerHtml[0].ondragend = function () {
        container.viewer.draggingOver = false;
        if (!container.viewer.initialized) {
            container.viewer.drawEmptyViewer();
        }
        return false;
    };

    // TODO : Does not check the file type (but should work with all types supported by Papaya)
    this.containerHtml[0].ondrop = function (evt) {
        evt.preventDefault();

        var dataTransfer = evt.dataTransfer;

        // TODO : The loading is not displayed when uploading a .nii file
        //  (This should come from Papaya functions that are not called here.
        //  Ex: In addEditFile we only use the viewer.loadImage function and maybe not the ones needed for that)
        container.display.drawProgress(0.1, "Loading");

        if (dataTransfer) {
            console.log(dataTransfer.files)
            console.log(container.viewer.volume)
            if (dataTransfer.files.length > 1){
                container.display.drawError("You cannot upload more than one file at a time");
                return false;
            }
            addEditFile(dataTransfer.files);
        }

        return false;
    };
};