const express = require("express");

//Logger
const morgan = require("morgan"); // Middleware de logging
//Cors support
const cors = require("cors");
//Nunjucks
const nunjucks = require("nunjucks");
//Path
const path = require("path");

//Exports
//const router = require("./routes/index");
const {
    sequelize
} = require("./config/db");

const {
    createTable,
    createRating,
    displayTable,
} = require("./controllers/ratingsControler");
const {
    truncate
} = require("fs");

const router = require("./routes/index");

const app = express();

app.use(
    express.urlencoded({
        extended: true
    })
)

//Public folder for static ressources (css / images / etc)
app.use(express.static(path.join(__dirname, "/public")));
//app.use(express.static(__dirname + "/public"));
//app.use(express.static("public"));

app.set("view engine", "html");

nunjucks.configure(path.join(__dirname, "views"), {
    autoescape: true,
    express: app,
});

//Logger
app.use(morgan("combined"));

//CORS
app.use(cors({
    credentials: true
}));

//app.use("/", router);

async function connectDb() {
    try {
        await sequelize.authenticate();
        console.log("Connection has been established successfully.");
    } catch (error) {
        console.error("Unable to connect to the database:", error);
    }
}


app.use("/", router),
    //Starting Server
    app.listen(process.env.PORT || 5000, async function () {
        console.log("Papaya server listening on port 5000! 🚀");

        /*//Connecting to DB on start
  connectDb();

  //Creation de la table Rating pour test
  await createTable(true);

  //Ajout d'un rating à la table
  await createRating(
    "charles",
    "8716468",
    "10",
    "Un ptit commentaire pour tester"
  );*/

        //await displayTable();
});