const assert = require('assert');
const {By, Key} = require('selenium-webdriver');
const {waitLoadingPage, sleep} = require("./utils");


exports.runArrowShortcut = async function(driver, hash) {
    try {
        // test click on button Go To Center

        await driver.get("http://localhost:5000/preview?hash=" + hash);
        await waitLoadingPage(driver, "../client/src/public/data", hash);

        // click on Go To Center
        await driver.findElement(By.className("papaya-control-goto-center btn btn-user-preview")).click(); 
        await sleep(1000);

        // check if label name is ok
        let textLabel = await driver.findElement(By.id("labelName")).getText().then(function(value){
                        return value
                    });
            
        assert.strictEqual(textLabel, "Left lateral ventricle");
        console.log(" ✅ tests click on Go to center passed !");
    }catch(e){
        console.error( " ❌ ERROR on click on Go to center  tests");
    }

    try {
        // test arrow 

        let canvas = driver.findElement(By.css("#papayaViewer0 > canvas"));
        let offset = await canvas.getRect();
        let x = await offset.x;
        let y = await offset.y;
        const actions = driver.actions({async: true});
        await actions.move({x:parseInt(x),y:parseInt(y)}).perform();

        //key down 
        await actions.keyDown(Key.ARROW_DOWN).keyDown(Key.ARROW_DOWN).perform(); 

        // check if label name is ok
        let textLabel = await driver.findElement(By.id("labelName")).getText().then(function(value){
                        return value
                    });
            
        assert.strictEqual(textLabel, "Left cerebral WM");
        console.log(" ✅ tests click on arrow down passed !");
    }catch(e){
        console.error( " ❌ ERROR on click on arrow down  tests");
    }
}



