const assert = require('assert');
const {By} = require('selenium-webdriver');
const {waitLoadingPage} = require("./utils");


exports.runFileField = async function(driver, hash) {
    try {
        await driver.get("http://localhost:5000/preview?hash=" + hash);
        await waitLoadingPage(driver, "../client/src/public/data", hash);
 
        if(driver.findElements(By.id("View"))){
            console.log(" ✅ tests View passed !");
        }else{
            console.error( " ❌ ERROR View tests");
        }

        if(driver.findElements(By.id("Settings"))){
            console.log(" ✅ tests Settings passed !");
        }else{
            console.error( " ❌ ERROR Settings tests");
        }

        if(driver.findElements(By.id("Help"))){
            console.log(" ✅ tests Help passed !");
        }else{
            console.error( " ❌ ERROR Help tests");
        }

        if(driver.findElements(By.id("File")).then(elements => assert.strictEqual(elements.length,0))){
            console.log(" ✅ tests File passed !");
        }else{
            console.error( " ❌ ERROR File tests");
        }
    
    }catch(e){
        console.error( " ❌ ERROR runFileField tests");
    }
}



