const assert = require('assert');
const {By} = require('selenium-webdriver');
const {waitLoadingPage, sleep} = require("./utils");

async function verifyCheckedInput(driver, satisfied) {
    let checkGoodImage = await driver.findElement(By.id('checkGoodImage')).getAttribute('checked');
    let checkMediumImage = await driver.findElement(By.id('checkMediumImage')).getAttribute('checked');
    let checkBadImage = await driver.findElement(By.id('checkBadImage')).getAttribute('checked');
    let checkGoodSegmentation = await driver.findElement(By.id('checkGoodSegmentation')).getAttribute('checked');
    let checkMediumSegmentation = await driver.findElement(By.id('checkMediumSegmentation')).getAttribute('checked');
    let checkBadSegmentation = await driver.findElement(By.id('checkBadSegmentation')).getAttribute('checked');
    
    if(satisfied) {
        assert.strictEqual(checkGoodImage, "true");
        assert.strictEqual(checkGoodSegmentation, "true");
        assert.strictEqual(checkMediumImage, null);
        assert.strictEqual(checkMediumSegmentation, null);
    } else {
        assert.strictEqual(checkGoodImage, null);
        assert.strictEqual(checkGoodSegmentation, null);
        assert.strictEqual(checkMediumImage, "true");
        assert.strictEqual(checkMediumSegmentation, "true");
    }

    assert.strictEqual(checkBadImage, null);
    assert.strictEqual(checkBadSegmentation, null);
}

exports.runRedirectToQC = async function(driver, hash) {
    try {
        await driver.get("http://localhost:5000/preview?hash=" + hash);
        await waitLoadingPage(driver, "../client/src/public/data", hash);

        // click on Go To Center
        await driver.findElement(By.className("papaya-control-goto-center btn btn-user-preview")).click(); 
        await sleep(1000);
        await driver.findElement(By.css("#satisfiedButtons > a > button")).click();
        await sleep(1000);

        let textQuestion = await driver.findElement(By.id('questionTop')).getText().then(function(value){
            return value
        });

        assert.strictEqual(textQuestion, "How is the quality of the analysis ?");
        // await verifyCheckedInput(driver, true);

        console.log(" ✅ tests Satisfaction question redirect tests passed!");
    }catch(e){
        console.error( " ❌ ERROR on satisfaction question Yes button redirect  tests");
    }
}



